package info.bukova.isspst.dao.jpa;

import java.util.List;

import org.hibernate.Query;
import org.hibernate.SessionFactory;

import info.bukova.isspst.dao.BaseDao;

public abstract class BaseDaoJPA<T> implements BaseDao<T> {

	private SessionFactory sessionFactory;
	
	public void setSessionFactory(SessionFactory factory) {
		this.sessionFactory = factory;
	}
	
	@Override
	public void add(T entity) {
		sessionFactory.getCurrentSession().save(entity);
	}

	@Override
	public void delete(T entity) {
		sessionFactory.getCurrentSession().delete(entity);
	}

	@Override
	public void modify(T entity) {
		sessionFactory.getCurrentSession().update(entity);
	}

	@SuppressWarnings("unchecked")
	@Override
	public T getById(int id) {
		Query q = sessionFactory.getCurrentSession().createQuery("from " + getEntityName() + " e where ID = :id");
		q.setInteger("id", id);
		return (T) q.uniqueResult();
	}
	
	@Override
	public Query getQuery(String query) {
		return sessionFactory.getCurrentSession().createQuery(query);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public List<T> execQuery(String query) {
		return sessionFactory.getCurrentSession().createQuery(query).list();
	}
	
	@SuppressWarnings("unchecked")
	@Override
	public List<T> getAll() {
		return sessionFactory.getCurrentSession().createQuery("from " + getEntityName()).list();
	}

}
